option explicit

Main( )

sub Main( )
    dim objArgs, shared_connection, private_connection,operation
    Set objArgs = WScript.Arguments
	'

    if ((objArgs.Count > 0) ) then
        shared_connection = objArgs(0)
        private_connection = objArgs(1)
        operation = objArgs(2) 'true/false -> enable/disable ICS
        EnableDisableICS shared_connection,private_connection, operation
    else
        DIM Msg
        Msg = "Error_001x1: Invalid usage of Internet Connection Sharing Service(ICS)."
        WScript.Echo( Msg )  
    end if
end sub

Function IsCScript()
    ' Check whether CScript.exe is the host.
    If (InStr(UCase(WScript.FullName), "CSCRIPT") <> 0) Then
        IsCScript = True
    Else
        IsCScript = False
    End If
End function

function EnableDisableICS(internetConnection, virtualWifiConnection, ics_option)
    
    dim  bFound
	dim bError
	bError=FALSE
    bFound = FALSE
    dim oNetSharingManager, oConnectionCollection, oItem, EveryConnection, objNCProps
    
    set oNetSharingManager = Wscript.CreateObject("HNetCfg.HNetShare.1")
     if (IsObject(oNetSharingManager)) = FALSE then
        bError=TRUE
    End if
    
    if (IsNull(oNetSharingManager.SharingInstalled) = TRUE) then
        Wscript.Echo( "Error_001x2: Connection Sharing is not available on this platform.")
        Exit function
    End if

     set oConnectionCollection = oNetSharingManager.EnumEveryConnection
    for each oItem In oConnectionCollection
        set EveryConnection = oNetSharingManager.INetSharingConfigurationForINetConnection (oItem)
        set objNCProps = oNetSharingManager.NetConnectionProps (oItem)
         If  objNCProps.name = virtualWifiConnection Then
            bFound = True
            If ics_option Then
                EveryConnection.EnableSharing (1)
            Else
                EveryConnection.DisableSharing
            End if
        End if
    Next

    set oConnectionCollection = oNetSharingManager.EnumEveryConnection
    for each oItem In oConnectionCollection
        set EveryConnection = oNetSharingManager.INetSharingConfigurationForINetConnection (oItem)
        set objNCProps = oNetSharingManager.NetConnectionProps (oItem)
        
        If  objNCProps.name = internetConnection Then
            bFound = True
            If ics_option Then
                EveryConnection.EnableSharing (0)
            Else
                EveryConnection.DisableSharing
            End if
        End if
    next
    
    If Not bFound Then
       bError=TRUE
    End if
	
	If bError = TRUE Then
	Wscript.Echo( "Erorr_001x3: Internet Connection Sharing could not be applied.")
	Else
		If ( IsCScript()) Then
		Wscript.Echo( "Shared_successfully. Enable:"+ics_option)
		End If

	End If

end function
